/*
 * BinaryOp.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;

import java.util.HashMap;
/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public abstract class BinaryOp extends Expression {
  protected Expression lhs;
  protected Expression rhs;
  
  /**
   *
   */
  public BinaryOp() {
    super();
    this.lhs = null;
    this.rhs = null;
  }
  
  /**
   *
   */
  public BinaryOp(Expression lhs, Expression rhs) {
    super();
    this.lhs = lhs;
    this.rhs = rhs;
  }
  
  /**
   *
   */
  public Expression getLHS() {
    return lhs;
  }
  
  /**
   *
   */
  public void setLHS(Expression e) {
    lhs = e;
  }
  
  /**
   *
   */
  public Expression getRHS() {
    return rhs;
  }
  
  /**
   *
   */
  public void setRHS(Expression e) {
    rhs = e;
  }
  
  public void bindParameters(HashMap<String,GridData> map) {
    lhs.bindParameters(map);
    rhs.bindParameters(map);
  }
  
}