/*
 * DoubleLiteral.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;

/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public class DoubleLiteral extends Expression {
  private double value;
  
  /**
   *
   */
  public DoubleLiteral() {
    super();
    value = -1.234;
  }
  
  /**
   *
   */
  public DoubleLiteral(double value) {
    super();
    this.value = value;
  }
  
  /**
   *
   */
  public double getValue() {
    return value;
  }
  
  /**
   *
   */
  public void setValue(double value) {
    this.value = value;
  }
  
  /**
   *
   */
  public String toString() {
    return "" + value;
  }
  
  /**
   *
   */
  public String toNoParenString() {
    return toString();
  }
  
  
}
