/*
 * Grid.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;


/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public class Grid {
  private String name;
  private int numDims;
  private Region bounds;
  
  public Grid() {
    super();
    this.bounds = null;
  }
  
  public Grid(String name, int numDims) {
    super();
    this.name = name;
    this.numDims = numDims;
    this.bounds = null;
  }
  
  public Grid(String name, Region bounds) {
    super();
    this.name = name;
    this.bounds = bounds;
    this.numDims = bounds.getSubregions().size();
  }
  
  /**
   *
   */
  public String getName() {
    return name;
  }
  
  /**
   *
   */
  public void setName(String name) {
    this.name = name;
  }
  
  /**
   *
   */
  public int getNumDims() {
    return numDims;
  }
  
  /**
   *
   */
  public Region getBounds() {
    return bounds;
  }
  
  /**
   *
   */
  public void setBounds(Region r) {
    bounds = r;
    numDims = r.getSubregions().size();
  }
  
}