/*
 * Iteration.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;

import java.util.ArrayList;

/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public class Iteration {
  //private Expression maxIterations;
  //private Expression checkEvery;
  private long maxIterations;
  private long checkEvery;
  private Expression convergeCheck;
  
  private ArrayList<Computable>    computables;

  
  /**
   *
   */
   public void setConvergeCheck(Expression e) {
     this.convergeCheck = e;
   }
   
  /**
   *
   */
   public Expression getConvergeCheck() {
     return this.convergeCheck;
   }
   
  /**
   *
   */
   //public void setMaxIterations(Expression maxIterations) {
   public void setMaxIterations(long maxIterations) {
     this.maxIterations = maxIterations;
   }
   
  /**
   *
   */
   //public Expression getMaxIterations() {
   public long getMaxIterations() {
     return this.maxIterations;
   }
   
  /**
   *
   */
   //public void setCheckEvery(Expression checkEvery) {
   public void setCheckEvery(long checkEvery) {
     this.checkEvery = checkEvery;
   }
   
  /**
   *
   */
   //public Expression getCheckEvery() {
   public long getCheckEvery() {
     return this.checkEvery;
   }
  
  /**
   *
   */
  public void addComputable(Computable c) {
    computables.add(c);
  }
  
  /**
   *
   */
  public ArrayList<Computable> getComputables() {
    return computables;
  }
  
  /**
   *
   */
  public void setComputables(ArrayList<Computable> computables) {
    this.computables = computables;
  }
  
  /**
   *
   */
  public void addStencil(Stencil s) {
    computables.add(s);
  }
  
  /**
   *
   */
  public ArrayList<Stencil> getStencils() {
    ArrayList<Stencil> stencils = new ArrayList<Stencil>();
    for (Computable c : computables) {
      if (c instanceof Stencil) {
        stencils.add((Stencil)c);
      }
    }
    return stencils;
  }
   
  /**
   *
   */
  public void addReduction(Reduction r) {
    computables.add(r);
  }
  
  /**
   *
   */
  public ArrayList<Reduction> getReductions() {
    ArrayList<Reduction> reductions = new ArrayList<Reduction>();
    for (Computable c : computables) {
      if (c instanceof Reduction) {
        reductions.add((Reduction)c);
      }
    }
    return reductions;
  }
  
}
