/*
 * LongLiteral.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;

/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public class LongLiteral extends Expression {
  private long value;
  
  /**
   *
   */
  public LongLiteral() {
    super();
    value = -1234;
  }
  
  /**
   *
   */
  public LongLiteral(long value) {
    super();
    this.value = value;
  }
  
  /**
   *
   */
  public long getValue() {
    return value;
  }
  
  /**
   *
   */
  public void setValue(long value) {
    this.value = value;
  }
  
  /**
   *
   */
  public String toString() {
    return "" + value + "l";
  }
  
  /**
   *
   */
  public String toNoParenString() {
    return toString();
  }
}
