/*
 * NotEqualTo.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;

/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public class NotEqualTo extends BinaryOp {
  
  /**
   *
   */
  public NotEqualTo() {
    super();
  }
  
  /**
   *
   */
  public NotEqualTo(Expression lhs, Expression rhs) {
    super(lhs,rhs);
  }
  
  /**
   *
   */
  public String toString() {
    return "(" + lhs + " != " + rhs + ")";
  }
  
  /**
   *
   */
  public String toNoParenString() {
    return lhs + " != " + rhs;
  }
}
