/*
 * Reduction.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;



import java.util.ArrayList;

/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public class Reduction implements Computable {
  private String name;
  private String assocOp;
  
  ArrayList<ReductionStatement> statements;
  
  /**
   *
   */
  public Reduction() {
    super();
    this.name = null;
    this.assocOp = null;
    statements = new ArrayList<ReductionStatement>();
  }
  
  /**
   *
   */
  public Reduction(String name, String assocOp, ArrayList<ReductionStatement> statements) {
    super();
    this.name = name;
    this.assocOp = assocOp;
    this.statements = statements;
  }
  
  /**
   *
   */
  public String getName() {
    return name;
  }
  
  /**
   *
   */
  public void setName(String name) {
    this.name = name;
  }
  
  /**
   *
   */
  public String getAssocOp() {
    return assocOp;
  }
  
  /**
   *
   */
  public void setAssocOp(String assocOp) {
    this.assocOp = assocOp;
  }
  
  /**
   *
   */
  public void addStatement(ReductionStatement s) {
    statements.add(s);
  }
  
  /**
   *
   */
  public ArrayList<ReductionStatement> getStatements() {
    return statements;
  }
}