/*
 * ReductionStatement.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;

/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public class ReductionStatement {
  private Region region;
  private Expression expression;
  
  /**
   *
   */
  public ReductionStatement() {
    super();
    region = null;
    expression = null;
  }
  
  /**
   *
   */
  public ReductionStatement(Region r, Expression e) {
    super();
    region = r;
    expression = e;
  }
  
  /**
   *
   */
  public Region getRegion() {
    return region;
  }
  
  /**
   *
   */
  public void setRegion(Region r) {
    region = r;
  }
  
  /**
   *
   */
  public Expression getExpression() {
    return expression;
  }
  
  /**
   *
   */
  public void setExpression(Expression e) {
    expression = e;
  }
  
  /**
   *
   */
  public String toString() {
    return expression.toString() + ";";
  }
}
