/*
 * Region.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;



import java.util.ArrayList;

/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public class Region {
  private ArrayList<Subregion> subregions;
  private boolean isConst;
  
  /**
   *
   */
  public Region() {
   super();
   subregions = null;
   isConst = false;
  }
   
  /**
   *
   */
  public Region(ArrayList<Subregion> subregions, boolean isConst) {
   super();
   this.subregions = subregions;
   this.isConst = isConst;
  }
  
  /**
   *
   */
  public void setConstRegion(boolean isConst) {
    this.isConst = isConst;
  }
  
  /**
   *
   */
  public boolean isConstRegion() {
    return isConst;
  }
  
  /**
   *
   */
  public void setSubregions(ArrayList<Subregion> subregions) {
    this.subregions = subregions;
  }
  
  /**
   *
   */
  public ArrayList<Subregion> getSubregions() {
    return subregions;
  }
}