/*
 * SpaceRef.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;

/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public class SpaceRef {
  private Expression ref;
  private boolean isConstant;
  
  /**
   *
   */
   public SpaceRef() {
     super();
     ref = null;
     isConstant = false;
   }
   
  /**
   *
   */
   public SpaceRef(Expression ref, boolean isConstant) {
     super();
     this.ref = ref;
     this.isConstant = isConstant;
   }
   
   public Expression getRef() {
     return ref;
   }
   
   public void setRef(Expression e) {
     ref = e;
   }
   
   public boolean isConstant() {
     return isConstant;
   }
   
   public void setConstant(boolean isConstant) {
     this.isConstant = isConstant;
   }
}