/*
 * Stencil.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;

import java.util.ArrayList;

/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public class Stencil implements Computable {
  private String name;
  ArrayList<StencilStatement> statements;
  
  /**
   *
   */
  public Stencil() {
    super();
    statements = new ArrayList<StencilStatement>();
  }
  
  /**
   *
   */
  public Stencil(String name, ArrayList<StencilStatement> statements) {
    super();
    this.name = name;
    this.statements = statements;
  }
  
  /**
   *
   */
  public String getName() {
    return name;
  }
  
  /**
   *
   */
  public void setName(String name) {
    this.name = name;
  }
  
  /**
   *
   */
  public void addStatement(StencilStatement s) {
    statements.add(s);
  }
  
  /**
   *
   */
  public ArrayList<StencilStatement> getStatements() {
    return statements;
  }
  
}
