/*
 * StencilStatement.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;

/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public class StencilStatement {
  private Region region;
  private Statement statement;
  
  /**
   *
   */
  public StencilStatement() {
    super();
    region = null;
    statement = null;
  }
  
  /**
   *
   */
  public StencilStatement(Region r, Statement s) {
    super();
    region = r;
    statement = s;
  }
  
  /**
   *
   */
  public Region getRegion() {
    return region;
  }
  
  /**
   *
   */
  public void setRegion(Region r) {
    region = r;
  }
  
  /**
   *
   */
  public Statement getStatement() {
    return statement;
  }
  
  /**
   *
   */
  public void setStatement(Statement s) {
    statement = s;
  }
  
  public String toString() {
    return statement.toString();
  }
}
