/*
 * Subregion.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;


/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */ 
public class Subregion {
  boolean isConst;
  
  Expression lb;
  Expression ub;
  
  /**
   *
   */
  public Subregion() {
    super();
    isConst = false;
    
    lb = null;
    ub = null;
  }
  
  /**
   *
   */
  public Subregion(Expression lbub, boolean isConst) {
    super();
    this.isConst = isConst;
    this.lb = lbub;
    this.ub = lbub;
  }
  
  /**
   *
   */
  public Subregion(Expression lb, Expression ub, boolean isConst) {
    super();
    this.isConst = isConst;
    this.lb = lb;
    this.ub = ub;
  }
  
  /**
   *
   */
  public void setConstSubregion(boolean isConst) {
    this.isConst = isConst;
  }
  
  /**
   *
   */
  public boolean isConstSubregion() {
    return isConst;
  }
  
  /**
   *
   */
  public void setLB(Expression lb) {
    this.lb = lb;
  }
  
  /**
   *
   */
  public Expression getLB() {
    return lb;
  }
  
  /**
   *
   */
  public void setUB(Expression ub) {
    this.ub = ub;
  }
  
  /**
   *
   */
  public Expression getUB() {
    return ub;
  }
}
