/*
 * UnaryOp.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
package edu.osu.cse.hpcrl.sdsl.ir;

import java.util.HashMap;
/**
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 */
public abstract class UnaryOp extends Expression {
  protected Expression operand;
  
  /**
   *
   */
  public UnaryOp() {
    super();
    this.operand = null;
  }
  
  /**
   *
   */
  public UnaryOp(Expression operand) {
    super();
    this.operand = operand;
  }
  
  /**
   *
   */
  public Expression getOperand() {
    return operand;
  }
  
  /**
   *
   */
  public void setOperand(Expression e) {
    operand = e;
  }
  
  public void bindParameters(HashMap<String,GridData> map) {
    operand.bindParameters(map);
  }
  
}