/*
 * ExitCodes.java: This file is part of the SDSLC project.
 *
 * SDSLC: A compiler for high performance stencil computations
 *
 * Copyright (C) 2011-2013 Ohio State University
 *
 * This program can be redistributed and/or modified under the terms
 * of the license specified in the LICENSE.txt file at the root of the
 * project.
 *
 * Contact: P Sadayappan <saday@cse.ohio-state.edu>
 */
/**
 * 
 */
package edu.osu.cse.hpcrl.sdsl.util;

/**
 * Contains exit codes for the SDSL compiler.
 * 
 * @author Tom Henretty <henretty@cse.ohio-state.edu>
 *
 */
public final class ExitCodes {
  public static final int OK = 0;
  public static final int BAD_COMMAND_LINE = 1;
  public static final int LEX_FAILED = 2;
  public static final int PARSE_FAILED = 3;
  public static final int AST_OUTPUT_FAILED = 4;
  public static final int AST_IR_CONVERT_FAILED = 5;
  public static final int CODEGEN_FAILED = 6;
  public static final int FILE_READ_FAILED = 7;
  public static final int FILE_WRITE_FAILED = 8;
  public static final int SDSL_REPLACEMENT_FAILED = 9;
}
